# -*- coding: utf-8 -*-
# Generated by Django 1.11.10 on 2018-03-05 06:12
from __future__ import unicode_literals

import converter.validators
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    replaces = [('converter', '0001_initial'), ('converter', '0002_auto_20150608_1943'), ('converter', '0003_auto_20150704_0731'), ('converter', '0004_auto_20150704_0753'), ('converter', '0005_auto_20150708_0118'), ('converter', '0006_auto_20150708_0120'), ('converter', '0007_auto_20150711_0656'), ('converter', '0008_auto_20150711_0723'), ('converter', '0009_auto_20150714_2228'), ('converter', '0010_auto_20150815_0351'), ('converter', '0011_auto_20170118_1758'), ('converter', '0012_auto_20170714_2133')]

    initial = True

    dependencies = [
        ('contenttypes', '0001_initial'),
    ]

    operations = [
        migrations.CreateModel(
            name='Transformation',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('object_id', models.PositiveIntegerField()),
                ('order', models.PositiveIntegerField(blank=True, db_index=True, default=0, help_text='Order in which the transformations will be executed.', verbose_name='Order')),
                ('name', models.CharField(choices=[('rotate', 'Rotate: degrees'), ('zoom', 'Zoom: percent'), ('resize', 'Resize: width, height')], max_length=128, verbose_name='Name')),
                ('arguments', models.TextField(blank=True, help_text='Enter the arguments for the transformation as a YAML dictionary. ie: {"degrees": 180}', validators=[converter.validators.YAMLValidator()], verbose_name='Arguments')),
                ('content_type', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='contenttypes.ContentType')),
            ],
            options={
                'ordering': ('order',),
                'verbose_name': 'Transformation',
                'verbose_name_plural': 'Transformations',
            },
        ),
        migrations.AlterUniqueTogether(
            name='transformation',
            unique_together=set([('content_type', 'object_id', 'order')]),
        ),
        migrations.AlterField(
            model_name='transformation',
            name='order',
            field=models.PositiveIntegerField(blank=True, db_index=True, default=0, help_text='Order in which the transformations will be executed. If left unchanged, an automatic order value will be assigned.', verbose_name='Order'),
        ),
        migrations.AlterField(
            model_name='transformation',
            name='name',
            field=models.CharField(choices=[('rotate', 'Rotate: degrees'), ('zoom', 'Zoom: percent'), ('resize', 'Resize: width, height'), ('crop', 'Crop: left, top, right, bottom')], max_length=128, verbose_name='Name'),
        ),
        migrations.AlterField(
            model_name='transformation',
            name='name',
            field=models.CharField(choices=[('crop', 'Crop: left, top, right, bottom'), ('flip', 'Flip'), ('gaussianblur', 'Gaussian blur: radius'), ('mirror', 'Mirror'), ('resize', 'Resize: width, height'), ('rotate', 'Rotate: degrees'), ('rotate180', 'Rotate 180 degrees'), ('rotate270', 'Rotate 270 degrees'), ('rotate90', 'Rotate 90 degrees'), ('unsharpmask', 'Unsharp masking: radius, percent, threshold'), ('zoom', 'Zoom: percent')], max_length=128, verbose_name='Name'),
        ),
        migrations.AlterField(
            model_name='transformation',
            name='name',
            field=models.CharField(choices=[('crop', 'Crop: left, top, right, bottom'), ('flip', 'Flip'), ('gaussianblur', 'Gaussian blur: radius'), ('lineart', 'Line art'), ('mirror', 'Mirror'), ('resize', 'Resize: width, height'), ('rotate', 'Rotate: degrees'), ('rotate180', 'Rotate 180 degrees'), ('rotate270', 'Rotate 270 degrees'), ('rotate90', 'Rotate 90 degrees'), ('unsharpmask', 'Unsharp masking: radius, percent, threshold'), ('zoom', 'Zoom: percent')], max_length=128, verbose_name='Name'),
        ),
    ]
