# -*- coding: utf-8 -*-
# Generated by Django 1.11.10 on 2018-03-10 19:55
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion
import document_signatures.models
import storage.backends.filebasedstorage


class Migration(migrations.Migration):

    replaces = [('document_signatures', '0001_initial'), ('document_signatures', '0002_auto_20150608_1902'), ('document_signatures', '0003_auto_20160325_0052'), ('document_signatures', '0004_auto_20160325_0418'), ('document_signatures', '0005_auto_20160325_0748'), ('document_signatures', '0006_auto_20160326_0616')]

    dependencies = [
        ('documents', '0001_initial'),
        ('documents', '0033_auto_20160325_0052'),
    ]

    operations = [
        migrations.CreateModel(
            name='SignatureBaseModel',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('date', models.DateField(blank=True, null=True, verbose_name='Date signed')),
                ('key_id', models.CharField(max_length=40, verbose_name='Key ID')),
                ('signature_id', models.CharField(blank=True, max_length=64, null=True, verbose_name='Signature ID')),
                ('public_key_fingerprint', models.CharField(editable=False, max_length=40, unique=True, verbose_name='Public key fingerprint')),
            ],
            options={
                'verbose_name': 'Document version signature',
                'verbose_name_plural': 'Document version signatures',
            },
        ),
        migrations.CreateModel(
            name='DetachedSignature',
            fields=[
                ('signaturebasemodel_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='document_signatures.SignatureBaseModel')),
                ('signature_file', models.FileField(blank=True, null=True, storage=storage.backends.filebasedstorage.FileBasedStorage(), upload_to=document_signatures.models.upload_to, verbose_name='Signature file')),
            ],
            options={
                'verbose_name': 'Document version detached signature',
                'verbose_name_plural': 'Document version detached signatures',
            },
            bases=('document_signatures.signaturebasemodel',),
        ),
        migrations.CreateModel(
            name='EmbeddedSignature',
            fields=[
                ('signaturebasemodel_ptr', models.OneToOneField(auto_created=True, on_delete=django.db.models.deletion.CASCADE, parent_link=True, primary_key=True, serialize=False, to='document_signatures.SignatureBaseModel')),
            ],
            options={
                'verbose_name': 'Document version embedded signature',
                'verbose_name_plural': 'Document version embedded signatures',
            },
            bases=('document_signatures.signaturebasemodel',),
        ),
        migrations.AddField(
            model_name='signaturebasemodel',
            name='document_version',
            field=models.ForeignKey(editable=False, on_delete=django.db.models.deletion.CASCADE, related_name='signatures', to='documents.DocumentVersion', verbose_name='Document version'),
        ),
        migrations.AlterField(
            model_name='signaturebasemodel',
            name='date',
            field=models.DateField(blank=True, editable=False, null=True, verbose_name='Date signed'),
        ),
        migrations.AlterField(
            model_name='signaturebasemodel',
            name='public_key_fingerprint',
            field=models.CharField(blank=True, editable=False, max_length=40, null=True, unique=True, verbose_name='Public key fingerprint'),
        ),
        migrations.AlterField(
            model_name='signaturebasemodel',
            name='signature_id',
            field=models.CharField(blank=True, editable=False, max_length=64, null=True, verbose_name='Signature ID'),
        ),
        migrations.AlterField(
            model_name='signaturebasemodel',
            name='public_key_fingerprint',
            field=models.CharField(blank=True, editable=False, max_length=40, null=True, verbose_name='Public key fingerprint'),
        ),
    ]
