# -*- coding: utf-8 -*-
# Generated by Django 1.11.11 on 2018-03-20 05:46
from __future__ import unicode_literals

from django.conf import settings
from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    replaces = [('document_states', '0001_initial'), ('document_states', '0002_workflowstate_completion')]

    dependencies = [
        ('documents', '__first__'),
        migrations.swappable_dependency(settings.AUTH_USER_MODEL),
    ]

    operations = [
        migrations.CreateModel(
            name='Workflow',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.CharField(max_length=255, unique=True, verbose_name='Label')),
                ('document_types', models.ManyToManyField(related_name='workflows', to=b'documents.DocumentType', verbose_name='Document types')),
            ],
            options={
                'verbose_name': 'Workflow',
                'verbose_name_plural': 'Workflows',
            },
        ),
        migrations.CreateModel(
            name='WorkflowInstance',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('document', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='workflows', to='documents.Document', verbose_name='Document')),
                ('workflow', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='instances', to='document_states.Workflow', verbose_name='Workflow')),
            ],
            options={
                'verbose_name': 'Workflow instance',
                'verbose_name_plural': 'Workflow instances',
            },
        ),
        migrations.CreateModel(
            name='WorkflowInstanceLogEntry',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('datetime', models.DateTimeField(auto_now_add=True, db_index=True, verbose_name='Datetime')),
                ('comment', models.TextField(blank=True, verbose_name='Comment')),
            ],
            options={
                'verbose_name': 'Workflow instance log entry',
                'verbose_name_plural': 'Workflow instance log entries',
            },
        ),
        migrations.CreateModel(
            name='WorkflowState',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.CharField(max_length=255, verbose_name='Label')),
                ('initial', models.BooleanField(default=False, help_text='Select if this will be the state with which you want the workflow to start in. Only one state can be the initial state.', verbose_name='Initial')),
                ('workflow', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='states', to='document_states.Workflow', verbose_name='Workflow')),
            ],
            options={
                'verbose_name': 'Workflow state',
                'verbose_name_plural': 'Workflow states',
            },
        ),
        migrations.CreateModel(
            name='WorkflowTransition',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.CharField(max_length=255, verbose_name='Label')),
                ('destination_state', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='destination_transitions', to='document_states.WorkflowState', verbose_name='Destination state')),
                ('origin_state', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='origin_transitions', to='document_states.WorkflowState', verbose_name='Origin state')),
                ('workflow', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='transitions', to='document_states.Workflow', verbose_name='Workflow')),
            ],
            options={
                'verbose_name': 'Workflow transition',
                'verbose_name_plural': 'Workflow transitions',
            },
        ),
        migrations.AlterUniqueTogether(
            name='workflowtransition',
            unique_together=set([('workflow', 'label', 'origin_state', 'destination_state')]),
        ),
        migrations.AddField(
            model_name='workflowstate',
            name='completion',
            field=models.IntegerField(blank=True, default=0, help_text='Enter the percent of completion that this state represents in relation to the workflow. Use numbers without the percent sign.', verbose_name='Completion'),
        ),
        migrations.AlterUniqueTogether(
            name='workflowstate',
            unique_together=set([('workflow', 'label')]),
        ),
        migrations.AddField(
            model_name='workflowinstancelogentry',
            name='transition',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to='document_states.WorkflowTransition', verbose_name='Transition'),
        ),
        migrations.AddField(
            model_name='workflowinstancelogentry',
            name='user',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, to=settings.AUTH_USER_MODEL, verbose_name='User'),
        ),
        migrations.AddField(
            model_name='workflowinstancelogentry',
            name='workflow_instance',
            field=models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='log_entries', to='document_states.WorkflowInstance', verbose_name='Workflow instance'),
        ),
        migrations.AlterUniqueTogether(
            name='workflowinstance',
            unique_together=set([('document', 'workflow')]),
        ),
    ]
