# -*- coding: utf-8 -*-
# Generated by Django 1.11.10 on 2018-03-10 19:16
from __future__ import unicode_literals

from django.db import migrations, models
import django.db.models.deletion


class Migration(migrations.Migration):

    replaces = [('mailer', '0001_initial'), ('mailer', '0002_usermailer_usermailerlogentry'), ('mailer', '0003_auto_20170703_1535'), ('mailer', '0004_auto_20170714_2133'), ('mailer', '0005_auto_20170718_0123')]

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='LogEntry',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('datetime', models.DateTimeField(auto_now_add=True, verbose_name='Date time')),
                ('message', models.TextField(blank=True, editable=False, verbose_name='Message')),
            ],
            options={
                'ordering': ('-datetime',),
                'get_latest_by': 'datetime',
                'verbose_name': 'Log entry',
                'verbose_name_plural': 'Log entries',
            },
        ),
        migrations.CreateModel(
            name='UserMailer',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('label', models.CharField(max_length=32, unique=True, verbose_name='Label')),
                ('default', models.BooleanField(default=True, verbose_name='Default')),
                ('backend_path', models.CharField(help_text='The dotted Python path to the backend class.', max_length=128, verbose_name='Backend path')),
                ('backend_data', models.TextField(blank=True, verbose_name='Backend data')),
            ],
            options={
                'ordering': ('label',),
                'verbose_name': 'User mailer',
                'verbose_name_plural': 'User mailers',
            },
        ),
        migrations.CreateModel(
            name='UserMailerLogEntry',
            fields=[
                ('id', models.AutoField(auto_created=True, primary_key=True, serialize=False, verbose_name='ID')),
                ('datetime', models.DateTimeField(auto_now_add=True, verbose_name='Date time')),
                ('message', models.TextField(blank=True, editable=False, verbose_name='Message')),
                ('user_mailer', models.ForeignKey(on_delete=django.db.models.deletion.CASCADE, related_name='error_log', to='mailer.UserMailer', verbose_name='User mailer')),
            ],
            options={
                'ordering': ('-datetime',),
                'get_latest_by': 'datetime',
                'verbose_name': 'User mailer log entry',
                'verbose_name_plural': 'User mailer log entries',
            },
        ),
        migrations.AddField(
            model_name='usermailer',
            name='enabled',
            field=models.BooleanField(default=True, verbose_name='Enabled'),
        ),
        migrations.AlterField(
            model_name='usermailer',
            name='default',
            field=models.BooleanField(default=True, help_text='If default, this mailing profile will be pre-selected on the document mailing form.', verbose_name='Default'),
        ),
        migrations.AlterField(
            model_name='usermailer',
            name='label',
            field=models.CharField(max_length=128, unique=True, verbose_name='Label'),
        ),
    ]
